/*
  File autogenerated by gengetopt version 2.15
  generated with the following command:
  gengetopt --set-version= --set-package= --file-name=compress_filter.cmdline --func-name compress_cmdline_parser 

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "getopt.h"

#include "compress_filter.cmdline.h"

static
void clear_given (struct gengetopt_args_info *args_info);
static
void clear_args (struct gengetopt_args_info *args_info);

static int
compress_cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error);


static char *
gengetopt_strdup (const char *s);

static
void clear_given (struct gengetopt_args_info *args_info)
{
  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->anticlip_given = 0 ;
  args_info->buckets_given = 0 ;
  args_info->target_level_given = 0 ;
  args_info->gain_max_given = 0 ;
  args_info->gain_smooth_given = 0 ;
  args_info->volume_given = 0 ;
}

static
void clear_args (struct gengetopt_args_info *args_info)
{
  args_info->anticlip_flag = 1;
  args_info->buckets_arg = 400;
  args_info->buckets_orig = NULL;
  args_info->target_level_arg = 25000;
  args_info->target_level_orig = NULL;
  args_info->gain_max_arg = 4;
  args_info->gain_max_orig = NULL;
  args_info->gain_smooth_arg = 5;
  args_info->gain_smooth_orig = NULL;
  args_info->volume_arg = 10;
  args_info->volume_orig = NULL;
  
}

void
compress_cmdline_parser_print_version (void)
{
  printf ("%s %s\n", COMPRESS_CMDLINE_PARSER_PACKAGE, COMPRESS_CMDLINE_PARSER_VERSION);
}

void
compress_cmdline_parser_print_help (void)
{
  compress_cmdline_parser_print_version ();
  printf("\nUsage:  [OPTIONS]...\n\n");
  printf("%s\n","  -h, --help                 Print help and exit");
  printf("%s\n","  -V, --version              Print version and exit");
  printf("%s\n","\nThe dynamic audio range compressor:");
  printf("%s\n","  -c, --anticlip             enable clipping protection  (default=on)");
  printf("%s\n","  -b, --buckets=number       history length  (default=`400')");
  printf("%s\n","  -t, --target_level=number  target signal level (1-32767)  (default=`25000')");
  printf("%s\n","  -g, --gain_max=number      maximum amount to amplify by  (default=`4')");
  printf("%s\n","  -i, --gain_smooth=number   how much inertia ramping has  (default=`5')");
  printf("%s\n","  -v, --volume=number        set soft volume (0-10)  (default=`10')");
  
}

void
compress_cmdline_parser_init (struct gengetopt_args_info *args_info)
{
  clear_given (args_info);
  clear_args (args_info);
}

static void
compress_cmdline_parser_release (struct gengetopt_args_info *args_info)
{
  
  if (args_info->buckets_orig)
    {
      free (args_info->buckets_orig); /* free previous argument */
      args_info->buckets_orig = 0;
    }
  if (args_info->target_level_orig)
    {
      free (args_info->target_level_orig); /* free previous argument */
      args_info->target_level_orig = 0;
    }
  if (args_info->gain_max_orig)
    {
      free (args_info->gain_max_orig); /* free previous argument */
      args_info->gain_max_orig = 0;
    }
  if (args_info->gain_smooth_orig)
    {
      free (args_info->gain_smooth_orig); /* free previous argument */
      args_info->gain_smooth_orig = 0;
    }
  if (args_info->volume_orig)
    {
      free (args_info->volume_orig); /* free previous argument */
      args_info->volume_orig = 0;
    }
  
  clear_given (args_info);
}

int
compress_cmdline_parser_file_save(const char *filename, struct gengetopt_args_info *args_info)
{
  FILE *outfile;
  int i = 0;

  outfile = fopen(filename, "w");

  if (!outfile)
    {
      fprintf (stderr, "%s: cannot open file for writing: %s\n", COMPRESS_CMDLINE_PARSER_PACKAGE, filename);
      return EXIT_FAILURE;
    }

  if (args_info->help_given) {
    fprintf(outfile, "%s\n", "help");
  }
  if (args_info->version_given) {
    fprintf(outfile, "%s\n", "version");
  }
  if (args_info->anticlip_given) {
    fprintf(outfile, "%s\n", "anticlip");
  }
  if (args_info->buckets_given) {
    if (args_info->buckets_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "buckets", args_info->buckets_orig);
    } else {
      fprintf(outfile, "%s\n", "buckets");
    }
  }
  if (args_info->target_level_given) {
    if (args_info->target_level_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "target_level", args_info->target_level_orig);
    } else {
      fprintf(outfile, "%s\n", "target_level");
    }
  }
  if (args_info->gain_max_given) {
    if (args_info->gain_max_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "gain_max", args_info->gain_max_orig);
    } else {
      fprintf(outfile, "%s\n", "gain_max");
    }
  }
  if (args_info->gain_smooth_given) {
    if (args_info->gain_smooth_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "gain_smooth", args_info->gain_smooth_orig);
    } else {
      fprintf(outfile, "%s\n", "gain_smooth");
    }
  }
  if (args_info->volume_given) {
    if (args_info->volume_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "volume", args_info->volume_orig);
    } else {
      fprintf(outfile, "%s\n", "volume");
    }
  }
  
  fclose (outfile);

  i = EXIT_SUCCESS;
  return i;
}

void
compress_cmdline_parser_free (struct gengetopt_args_info *args_info)
{
  compress_cmdline_parser_release (args_info);
}


/* gengetopt_strdup() */
/* strdup.c replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = NULL;
  if (!s)
    return result;

  result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

int
compress_cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info)
{
  return compress_cmdline_parser2 (argc, argv, args_info, 0, 1, 1);
}

int
compress_cmdline_parser2 (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required)
{
  int result;

  result = compress_cmdline_parser_internal (argc, argv, args_info, override, initialize, check_required, NULL);

  if (result == EXIT_FAILURE)
    {
      compress_cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
compress_cmdline_parser_required (struct gengetopt_args_info *args_info, const char *prog_name)
{
  return EXIT_SUCCESS;
}

int
compress_cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error)
{
  int c;	/* Character of the parsed option.  */

  int error = 0;
  struct gengetopt_args_info local_args_info;

  if (initialize)
    compress_cmdline_parser_init (args_info);

  compress_cmdline_parser_init (&local_args_info);

  optarg = 0;
  optind = 1;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      char *stop_char;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "anticlip",	0, NULL, 'c' },
        { "buckets",	1, NULL, 'b' },
        { "target_level",	1, NULL, 't' },
        { "gain_max",	1, NULL, 'g' },
        { "gain_smooth",	1, NULL, 'i' },
        { "volume",	1, NULL, 'v' },
        { NULL,	0, NULL, 0 }
      };

      stop_char = 0;
      c = getopt_long (argc, argv, "hVcb:t:g:i:v:", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          compress_cmdline_parser_print_help ();
          compress_cmdline_parser_free (&local_args_info);
          exit (EXIT_SUCCESS);

        case 'V':	/* Print version and exit.  */
          compress_cmdline_parser_print_version ();
          compress_cmdline_parser_free (&local_args_info);
          exit (EXIT_SUCCESS);

        case 'c':	/* enable clipping protection.  */
          if (local_args_info.anticlip_given)
            {
              fprintf (stderr, "%s: `--anticlip' (`-c') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->anticlip_given && ! override)
            continue;
          local_args_info.anticlip_given = 1;
          args_info->anticlip_given = 1;
          args_info->anticlip_flag = !(args_info->anticlip_flag);
          break;

        case 'b':	/* history length.  */
          if (local_args_info.buckets_given)
            {
              fprintf (stderr, "%s: `--buckets' (`-b') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->buckets_given && ! override)
            continue;
          local_args_info.buckets_given = 1;
          args_info->buckets_given = 1;
          args_info->buckets_arg = strtol (optarg, &stop_char, 0);
          if (!(stop_char && *stop_char == '\0')) {
            fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
            goto failure;
          }
          if (args_info->buckets_orig)
            free (args_info->buckets_orig); /* free previous string */
          args_info->buckets_orig = gengetopt_strdup (optarg);
          break;

        case 't':	/* target signal level (1-32767).  */
          if (local_args_info.target_level_given)
            {
              fprintf (stderr, "%s: `--target_level' (`-t') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->target_level_given && ! override)
            continue;
          local_args_info.target_level_given = 1;
          args_info->target_level_given = 1;
          args_info->target_level_arg = strtol (optarg, &stop_char, 0);
          if (!(stop_char && *stop_char == '\0')) {
            fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
            goto failure;
          }
          if (args_info->target_level_orig)
            free (args_info->target_level_orig); /* free previous string */
          args_info->target_level_orig = gengetopt_strdup (optarg);
          break;

        case 'g':	/* maximum amount to amplify by.  */
          if (local_args_info.gain_max_given)
            {
              fprintf (stderr, "%s: `--gain_max' (`-g') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->gain_max_given && ! override)
            continue;
          local_args_info.gain_max_given = 1;
          args_info->gain_max_given = 1;
          args_info->gain_max_arg = strtol (optarg, &stop_char, 0);
          if (!(stop_char && *stop_char == '\0')) {
            fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
            goto failure;
          }
          if (args_info->gain_max_orig)
            free (args_info->gain_max_orig); /* free previous string */
          args_info->gain_max_orig = gengetopt_strdup (optarg);
          break;

        case 'i':	/* how much inertia ramping has.  */
          if (local_args_info.gain_smooth_given)
            {
              fprintf (stderr, "%s: `--gain_smooth' (`-i') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->gain_smooth_given && ! override)
            continue;
          local_args_info.gain_smooth_given = 1;
          args_info->gain_smooth_given = 1;
          args_info->gain_smooth_arg = strtol (optarg, &stop_char, 0);
          if (!(stop_char && *stop_char == '\0')) {
            fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
            goto failure;
          }
          if (args_info->gain_smooth_orig)
            free (args_info->gain_smooth_orig); /* free previous string */
          args_info->gain_smooth_orig = gengetopt_strdup (optarg);
          break;

        case 'v':	/* set soft volume (0-10).  */
          if (local_args_info.volume_given)
            {
              fprintf (stderr, "%s: `--volume' (`-v') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->volume_given && ! override)
            continue;
          local_args_info.volume_given = 1;
          args_info->volume_given = 1;
          args_info->volume_arg = strtol (optarg, &stop_char, 0);
          if (!(stop_char && *stop_char == '\0')) {
            fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
            goto failure;
          }
          if (args_info->volume_orig)
            free (args_info->volume_orig); /* free previous string */
          args_info->volume_orig = gengetopt_strdup (optarg);
          break;


        case 0:	/* Long option with no short option */
        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          goto failure;

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c%s\n", COMPRESS_CMDLINE_PARSER_PACKAGE, c, (additional_error ? additional_error : ""));
          abort ();
        } /* switch */
    } /* while */




  compress_cmdline_parser_release (&local_args_info);

  if ( error )
    return (EXIT_FAILURE);

  return 0;

failure:
  
  compress_cmdline_parser_release (&local_args_info);
  return (EXIT_FAILURE);
}
